import 'dart:html';

import 'package:sketch/sketch.dart';
import 'package:observe/observe.dart';

void main() {
    // Router binding
    var router = new SimpleRouter.from([
        new SimpleView('#tasks', 'views/task_list.html', (List parameters) {
            var output = new ObservableList<Map>();
            return {
                'tasks': [{'id': 1, 'description': 'Task 1', 'edit': (Event event, Router router) {
                    router.path = '#tasks/' + task.id.toString();
                }}],
                'add': (Event event, Router router) {
                    router.path = '#tasks/add';
                }
            };
        }),
        new SimpleView('#tasks/add', 'views/task_form.html', {
            'id': 'new',
            'description': '',
            'projects': [
                {'id': 1, 'description': 'Project 1'},
                {'id': 2, 'description': 'Project 2'},
                {'id': 3, 'description': 'Project 3'}
            ],
            'save': (Event event, Router router, Map bindings) {

            },
            'delete': (Event event, Router router, Map bindings) {

            }
        }),
        new SimpleView(r'#tasks/(\d+)', 'views/task_form.html', (List parameters) {
            var bindings = new ObservableMap.from({
                'id': null,
                'description': null,
                'projects': new ObservableList(),
                'save': (Event event, Router router, Map bindings) {

                },
                'delete': (Event event, Router router, Map bindings) {

                }
            });
            return bindings;
        })
    ]);
    new Template.bind('#stage', {
        'router': router
    });
}